//                                                                                
//    Copyright (c) 2004/2005 Thomas Fuchs / The Rockin'-B, www.rockin-b.de       
//                                                                                
//    Permission is granted to anyone to use this software for any purpose        
//    and to redistribute it freely, subject to the following restrictions:       
//                                                                                
//    1.  The origin of this software must not be misrepresented. You must not    
//        claim that you wrote the original software. If you use this software    
//        in a product, an acknowledgment in the product documentation would be   
//        appreciated but is not required.                                        
//                                                                                
//    2.  ANY COMMERCIAL USE IS PROHIBITED. This includes that you must not use   
//        this software in the production of a commercial product. Only an explicit
//        permission by the author can allow you to do that.                      
//                                                                                
//    3.  Any modification applied to the software must be marked as such clearly.
//                                                                                
//    4.  This license may not be removed or altered from any distribution.       
//                                                                                
//                                                                                
//    			    NO WARRANTY                                                 
//                                                                                
//    THERE IS NO WARRANTY FOR THE PROGRAM.                                       
//    THE PROGRAM IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND,               
//    EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO,                 
//    THE IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR PURPOSE.                 
//    THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH YOU.
//    SHOULD THE PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY    
//    SERVICING, REPAIR OR CORRECTION.                                            
//                                                                                
//    IN NO EVENT WILL THE COPYRIGHT HOLDER BE LIABLE TO YOU FOR DAMAGES,         
//    INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING 
//    OUT OF THE USE OR INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT LIMITED   
//    TO LOSS OF DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY    
//    YOU OR THIRD PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY OTHER  
//    PROGRAMS), EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE       
//    POSSIBILITY OF SUCH DAMAGES.                                                
//                                                                                

/********************************************************************
     < SGL Ver3.00 Sample Program >
  Sample Name : 3D Driving Sample(Near Clipping)
  Author      : H.S
  Date        : 09/10/1996
********************************************************************/

// Changes by the Rockin'-B
// - reduced number of slSin and slCos calls by using sineY, cosineY
// - applied collision optimization from SHOOTING example with flag COL_NO_SQRT
// - text display of collision type
//      ->attribute 1 is on track, 2 is side collision, no other is used by the original map
// - trying to display custom maps generated with RB_SaturnMAP
//


// Questions:
// - tak_data
//      influences pos[Z]
//      pressing C or Z got no effect, although it increases/decreases tak_data
//
// - ang_z
//       car looking down or up
//       according to surface
//
// - ang_add
//      influences both, ang[Z] and ang[Y]
//      is set by:
//          KL + KR set ang_add
//          collision response
//      decreases always
//
// - pos_add
//      speed influence on movement
//
// - col_x, col_y
//      both influence pos_add
//      make the car run down a hill automatically
//
// why does slPushMatrix crash with unknown opcode for the wheel?

#include	"sgl.h"
#include	"sgl_cd.h"
#include	"sega_sys.h"

#include	"sglcolli.h"

#include <RB_were_here.h>
#define GROUND_SATURN
#define toFLOAT(fx)			(((float)fx) / 65536.0)
#include "RB_POL_def.h"
#include "RB_MAP_def.h"
#include "RB_DRV_def.h"
#include "RB_DRV_draw.h"

Player player1, player2;
//MapData *map;


// 3D menu stuff
#include <RB_TXT_SCROLL.h>
#include "RB_menu3D.h"
#define	TXT_SCROLL_XRES	40
#define TXT_SCROLL_YRES 30
void *txt_menu, *txt_scroll, *txt_screen;

void MENU3D_callback(int item, void *ptr);

// don't check tray on emulator!
//#define FLASH_SATURN_CD
#define COL_NO_SQRT
//#define MAKE_DRIVING2
#define USE_CUSTOM_MAP
#define USE_SCROLLS
//#define USE_DEPTH


#ifdef USE_CUSTOM_MAP
#   include	"./map/driving_0_0_1.mdl"
TEXTURE	tex_sample[] = {
};
PICTURE	pic_sample[] = {
};
#else
// polygon data
// !!! see below for some undefs
#ifdef MAKE_DRIVING2
    // from POLYGON.C
#   include	"./map/miti2.mdl"
#   include	"./map/miti2.ata"
    // from TEXTURE.C
#   include	"./map/tex/tex2.txr"
#else
    // from POLYGON.C
#   include	"./map/miti.mdl"
#   include	"./map/miti.ata"
    // from TEXTURE.C
#   include	"./map/tex/miti00.c"
#   include	"./map/tex/iwa.c"
#   include	"./map/tex/kusa00.c"
#   include	"./map/tex/kusa01.c"
#   include	"./map/tex/kusa02.c"
#   include	"./map/tex/ton00.c"
#   include	"./map/tex/miti01.c"

enum	cga	{
	MITI00	=CGADDRESS,
	IWA00	=AdjCG(MITI00,32,32,COL_32K),
	KUSA00	=AdjCG(IWA00,32,32,COL_32K),
	KUSA01	=AdjCG(KUSA00,32,32,COL_32K),
	KUSA02	=AdjCG(KUSA01,32,32,COL_32K),
	TON00	=AdjCG(KUSA02,32,32,COL_32K),
	MITI01	=AdjCG(TON00,32,32,COL_32K),
};
TEXTURE tex_sample[]={
	TEXDEF(32,32,MITI00),
	TEXDEF(32,32,IWA00),
	TEXDEF(32,32,KUSA00),
	TEXDEF(32,32,KUSA01),
	TEXDEF(32,32,KUSA02),
	TEXDEF(32,32,TON00),
	TEXDEF(32,32,MITI01),
};

PICTURE	pic_sample[]={
	PICDEF( 0,COL_32K,miti00_32X32),
	PICDEF( 1,COL_32K,iwa_32X32),
	PICDEF( 2,COL_32K,kusa00_32X32),
	PICDEF( 3,COL_32K,kusa01_32X32),
	PICDEF( 4,COL_32K,kusa02_32X32),
	PICDEF( 5,COL_32K,ton00_32X32),
	PICDEF( 6,COL_32K,miti01_32X32),
};
#endif
#undef      texno

#endif // USE_CUSTOM_MAP

#include	"init.h"

  
extern	Uint16	TotalPolygons;
extern	Uint16	DispPolygons;
//extern	TEXTURE	tex_sample[];
//extern	PICTURE	pic_sample[];
//extern	PDATA	*map_data[];
//extern	CDATA	*collison_data[];
#ifdef MAKE_DRIVING2
    // unused...
extern	XPDATA	*xpdata_Kirby_of_the_Star[];
#endif

#ifdef USE_SCROLLS
extern	Uint8	sora_cel[];
extern	Uint16	sora_map[];
extern	Uint16	sora_pal[];
extern	Uint8	tuti_cel[];
extern	Uint16	tuti_map[];
extern	Uint16	tuti_pal[];
extern	Uint32	pal_data[];
#endif


#define		RBG0RB_CEL_ADR			(VDP2_VRAM_A0            )
#define		RBG0RB_MAP_ADR			(VDP2_VRAM_B0            )
#define		RBG0RB_COL_ADR			(VDP2_COLRAM    + 0x00200)

#define		RBG0RA_CEL_ADR			(RBG0RB_CEL_ADR + 0x06e80)
#define		RBG0RA_MAP_ADR			(RBG0RB_MAP_ADR + 0x02000)
#define		RBG0RA_COL_ADR			(RBG0RB_COL_ADR + 0x00200)

#define		RBG0_KTB_ADR			(VDP2_VRAM_A1            )
#define		RBG0_PRA_ADR			(VDP2_VRAM_A1   + 0x1fe00)
#define		RBG0_PRB_ADR			(RBG0_PRA_ADR   + 0x00080)

#define		BACK_COL_ADR			(VDP2_VRAM_A1   + 0x1fffe)
#define		LINECOLOR				(VDP2_VRAM_A0   + 0x04000)




#ifdef USE_DEPTH
static	GOURAUDTBL	gr_tab[300];
static	Uint16	point_temp[300];

#define	GRTBL(r,g,b)	(((b&0x1f)<<10) | ((g&0x1f)<<5) | (r&0x1f) )
static	Uint16	DepthData[32] = {
	GRTBL( 16, 16, 16 ),
	GRTBL( 16, 16, 16 ),
	GRTBL( 16, 16, 16 ),
	GRTBL( 16, 16, 16 ),
	GRTBL( 16, 16, 16 ),
	GRTBL( 16, 16, 16 ),
	GRTBL( 16, 16, 16 ),
	GRTBL( 16, 16, 16 ),
	GRTBL( 16, 16, 16 ),
	GRTBL( 16, 16, 16 ),
	GRTBL( 16, 16, 16 ),
	GRTBL( 16, 16, 16 ),
	GRTBL( 16, 16, 16 ),
	GRTBL( 16, 16, 16 ),
	GRTBL( 16, 16, 16 ),
	GRTBL( 16, 16, 16 ),
	GRTBL( 15, 15, 15 ),
	GRTBL( 14, 14, 14 ),
	GRTBL( 13, 13, 13 ),
	GRTBL( 12, 12, 12 ),
	GRTBL( 11, 11, 11 ),
	GRTBL( 10, 10, 10 ),
	GRTBL(  9,  9,  9 ),
	GRTBL(  8,  8,  8 ),
	GRTBL(  7,  7,  7 ),
	GRTBL(  6,  6,  6 ),
	GRTBL(  5,  5,  5 ),
	GRTBL(  4,  4,  4 ),
	GRTBL(  3,  3,  3 ),
	GRTBL(  2,  2,  2 ),
	GRTBL(  1,  1,  1 ),
	GRTBL(  0,  0,  0 ),
};
#endif



Uint16 ZdspLevel;
Sint32 WindowClipLevel;
ANGLE Perspective;

FIXED light[XYZ];
ANGLE light_ang[XYZ];


// keep this in the libRB.a
//
//#define slMulFX_Ground(a, b) slMulFX(a, b)
//// neccessary on Saturn
//#define slDivFX_Ground(a, b) toFIXED(toFLOAT(a) / toFLOAT(b))
////#define slDivFX_Ground(a, b) slDivFX(a, b)
//
//#ifdef GROUND_SATURN
//ReturnValue MAP_checkGround(MapData *map, FIXED *pos, FIXED r2, FIXED sineY, FIXED cosineY, unsigned char *hit, unsigned char *typeID, FIXED *height, FIXED *directionX, FIXED *directionZ, FIXED *angleX, FIXED *angleZ)
//#else
//ReturnValue MAP_checkGround(MapData *map, FIXED *pos, unsigned char *hit, unsigned char *typeID, FIXED *height)
//#endif
//{
//    ReturnValue ret;
//    TileData *tile;
//    FIXED mapRelX, mapRelZ;
//    int minX, maxX, minZ, maxZ;
//    int x, z, g;
//#ifdef GROUND_SATURN
//    GroundData *ground = NULL;
//    FIXED dist, dist_min = r2;
//    FIXED dx, dz, DX, DZ;
//#endif    
//    
//    if((map == NULL) || (pos == NULL))
//        return RETURN_ERR_NULLARG;
//
//        
//	// find out the tile I'm in
//	   // OPTIMZABLE
////	mapRelX = slDivFX_Ground(pos[X] - map->mapOrigin.x, map->tileSize.x);
////	mapRelZ = slDivFX_Ground(pos[Z] - map->mapOrigin.z, map->tileSize.z);
//	mapRelX = (pos[X] - map->mapOrigin.x) >> (map->tileSize.x - 1);
//	mapRelZ = (pos[Z] - map->mapOrigin.z) >> (map->tileSize.z - 1);
//	
//	// out
//	// check the 4 nearest tiles
////	minX = (mapRelX - toFIXED(0.5)) >> 16;
//	minX = (mapRelX - 1) >> 1;
//    if(minX < 0)
//        minX = 0;
////	maxX = (mapRelX + toFIXED(0.5)) >> 16;
//	maxX = (mapRelX + 1) >> 1;
//	if(maxX >= map->mapSize.x)
//	   maxX = map->mapSize.x - 1;
////    // on map?
////    if(minX > maxX) {
////        *hit = 0;
////        return RETURN_OK;
////    }
//
////	minZ = (mapRelZ - toFIXED(0.5)) >> 16;
//	minZ = (mapRelZ - 1) >> 1;
//    if(minZ < 0)
//        minZ = 0;
////	maxZ = (mapRelZ + toFIXED(0.5)) >> 16;
//	maxZ = (mapRelZ + 1) >> 1;
//	if(maxZ >= map->mapSize.z)
//	   maxZ = map->mapSize.z - 1;
////    // on map?
////    if(minZ > maxZ) {
////        *hit = 0;
////        return RETURN_OK;
////    }
//	   
////	were_here("mapRelPos (%f, %f)", toFLOAT(mapRelX), toFLOAT(mapRelZ));
////    were_here("searching: x(%i, %i), z(%i, %i)!", minX, maxX, minZ, maxZ);
//	// search all 4 tiles
//    for(z = minZ; z <= maxZ; z++) {
//        for(x = minX; x <= maxX; x++) {
//            tile = *(map->tiles + z*map->mapSize.x + x);
//            if(tile == NULL)
//                continue;
//            // search all ground data
////            were_here("searching %i grounds!", tile->nGround);
//            for(g = 0; g < tile->nGround; g++) {
//#ifdef GROUND_SATURN
//                // 2D squared circle distance
//                dx = pos[X] - (tile->ground + g)->center[X];
//                dz = pos[Z] - (tile->ground + g)->center[Z];
//                dist = slMulFX_Ground(dx, dx) + slMulFX_Ground(dz, dz);
//                // track shortest distance
//                if(dist < dist_min) {
//                    dist_min = dist;
//                    DX = dx;
//                    DZ = dz;
//                    ground = tile->ground + g;
//                }
//#else            
//                // check hit
//                ret = POL_checkGround(tile->ground + g, pos, hit, typeID, height);
//                if(ret != RETURN_OK)
//                    return ret;
//                if(*hit == 1) {
////                    were_here("Found a hit in %i grounds!", tile->nGround);
//                    return RETURN_OK;
//                }    
//#endif
//            }
//        }                  
//    }
//    
//#ifdef GROUND_SATURN
//    // found a closest ground face?
//    if(ground == NULL) {
//        *hit = 0;
//        return RETURN_OK;
//    }
//    *hit = 1;
//    // now compute results
//    if(typeID != NULL)
//        *typeID = ground->typeID;
//    if(height != NULL) {
//        *height = slMulFX_Ground(ground->normal.x, DX) + slMulFX_Ground(ground->normal.z, DZ) + ground->center[Y];
////        note_printf("Center at (%f, %f, %f), height %f\n", toFLOAT(ground->center[X]), toFLOAT(ground->center[Y]), toFLOAT(ground->center[Z]), toFLOAT(*height));
//    }
//    if(directionX != NULL)
//        *directionX = ground->direction.x;
//    if(directionZ != NULL)
//        *directionZ = ground->direction.z;
//    
//    if(angleX != NULL) {
//        dx = slMulFX_Ground(ground->normal.x, sineY) + slMulFX_Ground(ground->normal.z, cosineY);
//        *angleX = slAtan(dx, toFIXED(1.0));
//    }
//    if(angleZ != NULL) {
//        dz = slMulFX_Ground(ground->normal.x, cosineY) + slMulFX_Ground(ground->normal.z, sineY);
//        *angleZ = slAtan(dz, toFIXED(1.0));
//    }
//#endif    
//    // no hit
//    return RETURN_OK;                  
//}


// debugging the ground detection
void checkGroundMap(MapData *map, unsigned int xRes, unsigned int zRes, FIXED r2)
{
    unsigned char hit;
    unsigned char typeID;
    FIXED height;  
    FIXED pos[XYZ];
    ReturnValue ret;
    int i, j;
    FIXED addX, addZ;
    
    addX = toFIXED(((float)map->mapSize.x)*toFLOAT(map->tileSize.x) / ((float)xRes));
    addZ = toFIXED(((float)map->mapSize.z)*toFLOAT(map->tileSize.z) / ((float)zRes));
    
    were_here("o(%f,%f) add(%f,%f)", toFLOAT(map->mapOrigin.x), toFLOAT(map->mapOrigin.z), toFLOAT(addX), toFLOAT(addZ));
    
    pos[Z] = map->mapOrigin.z;
    for(i = 0; i <= zRes; i++) {
        pos[Z] += addZ;
        pos[X] = map->mapOrigin.x;
        for(j = 0; j <= xRes; j++) {
            pos[X] += addX;
            ret = MAP_checkGround(map, pos, r2, 0, 0, &hit, &typeID, &height, NULL, NULL, NULL, NULL);
            if(ret != RETURN_OK) {
                were_here("Error checking map ground!\n");
            }
            if(hit == 1) {
                were_here("%i(%f, %f)%f\n", typeID, toFLOAT(pos[X]), toFLOAT(pos[Z]), toFLOAT(height));
            }    
        }
    }
    were_here("Finished!\n");
}


void DRV_initPlayer(Player *player)
{
    if(player == NULL)
        return;

    memset(player, 0, sizeof(Player));
    // camera
    player->cam.pos[X] = toFIXED(0.0);
    player->cam.pos[Y] = toFIXED(0.0);
    player->cam.pos[Z] = toFIXED(-11.0);
        
    player->cam.target[X] = toFIXED(0.0);
    player->cam.target[Y] = toFIXED(0.0);
    player->cam.target[Z] = toFIXED(0.0);

    player->cam.angZ = DEGtoANG(0.0);

    // drive
    player->drive.heightOffset = toFIXED(-4.0);
    player->drive.pos[X] = toFIXED(9.6731); //map->mapOrigin.x;
    player->drive.pos[Y] = toFIXED(-3.2104); //map->mapOrigin.z;
    player->drive.pos[Z] = toFIXED(110.0); 
    player->drive.ang[X] = DEGtoANG(0.0);
    player->drive.ang[Y] = DEGtoANG(0.0);
    player->drive.ang[Z] = DEGtoANG(0.0);

    player->drive.pos_add[X] = toFIXED(0.0);
    player->drive.pos_add[Y] = toFIXED(0.0);
    player->drive.pos_add[Z] = toFIXED(0.0);
    player->drive.pos_add2[X] = toFIXED(0.0);
    player->drive.pos_add2[Y] = toFIXED(0.0);
    player->drive.pos_add2[Z] = toFIXED(0.0);
    player->drive.pos_add2_xx = 0;
    player->drive.ang_add = DEGtoANG(0.0);
    player->drive.eg_speed = 0;
    
    // car
    player->car.width = 4;
    
    player->car.speed.unit = toFIXED(1.0/10.0);
    player->car.speed.max = toFIXED(45.0);
    player->car.speed.min = toFIXED(-30.0);

    player->car.ang.unit = DEGtoANG(2.0);
    player->car.paDec = toFIXED(4.0/5.0);
    player->car.pa2Dec = toFIXED(6.0/7.0);
    player->car.aaDec = toFIXED(4.0/5.0);
    player->car.downforce = 3;
}

#define	set_polygon	set_matrix
/*--------------------------------------------------------------------------*/
#ifdef USE_SCROLLS
void	init_vdp2()
{
	slRparaInitSet((void *)RBG0_PRA_ADR);
	slMakeKtable((void *)RBG0_KTB_ADR);
	slCharRbg0(COL_TYPE_256 , CHAR_SIZE_1x1);
	slPageRbg0((void *)RBG0RB_CEL_ADR , 0 , PNB_1WORD|CN_12BIT);
	
	slPlaneRA(PL_SIZE_1x1);
	sl1MapRA((void *)RBG0RA_MAP_ADR);
	slOverRA(0);
	slKtableRA((void *)RBG0_KTB_ADR , K_FIX | K_DOT | K_2WORD | K_ON | K_LINECOL);
	Cel2VRAM(tuti_cel , (void *)RBG0RA_CEL_ADR , 65536);
	Map2VRAM(tuti_map , (void *)RBG0RA_MAP_ADR , 64 , 64 , 2 , 884);
	Pal2CRAM(tuti_pal , (void *)RBG0RA_COL_ADR , 160);
	
	slPlaneRB(PL_SIZE_1x1);
	sl1MapRB((void *)RBG0RB_MAP_ADR);
	slOverRB(0);
	slKtableRB((void *)RBG0_KTB_ADR , K_FIX | K_DOT | K_2WORD | K_ON| K_LINECOL);
	Cel2VRAM(sora_cel , (void *)RBG0RB_CEL_ADR , 28288);
	Map2VRAM(sora_map , (void *)RBG0RB_MAP_ADR , 64 , 20 , 1 , 0);
	Pal2CRAM(sora_pal , (void *)RBG0RB_COL_ADR , 256);
	
	slRparaMode(K_CHANGE);
	slBack1ColSet((void *)BACK_COL_ADR , 0);
	
	slScrAutoDisp(NBG0ON | RBG0ON );
}
#endif





void DRV_movePos(Player *player)
{
    if(player == NULL)
        return;

    player->drive.pos2[X] = player->drive.pos[X];
    player->drive.pos2[Y] = player->drive.pos[Y];
    player->drive.pos2[Z] = player->drive.pos[Z];
    player->drive.ang2[X] = player->drive.ang[X];
    player->drive.ang2[Y] = player->drive.ang[Y];
    player->drive.ang2[Z] = player->drive.ang[Z];
}


void DRV_pad(Player *player, unsigned char nPer)
{
    Cam *cam;
    Drive *drive;
    Car *car;
    Coll *coll;
	FIXED		ax,ay,az;
	FIXED		bx,by,bz;
	Sint16		aa;
	Uint16		data;
	// collision
	FIXED collPoint[XYZ];

    if(player == NULL)
        return;
        
    cam = &(player->cam); 
    drive = &(player->drive);        
    car = &(player->car);        
    coll = &(player->coll);
    
// 2nd player pad for debug stuff
//	data = Smpc_Peripheral[15].data;
//    if((data & PER_DGT_TC) == 0)
//        drive->heightOffset += toFIXED(10);
//    if((data & PER_DGT_TZ) == 0)
//        drive->heightOffset -= toFIXED(10);
//// debug steering
//    aa = 0;
//	if((data & PER_DGT_KL) == 0) {
//	    aa = 1;
//        drive->ang[Y] += DEGtoANG(4.0);
//    }    
//	if((data & PER_DGT_KR) == 0) {
//	    aa = 1;
//        drive->ang[Y] -= DEGtoANG(4.0);
//    }   
//    if(aa == 1) { 
//        // everytime angZ is changed, compute the sine/cosine values
//        drive->sineY = slSin(drive->ang[Y]);
//        drive->cosineY = slCos(drive->ang[Y]);
//    }    
//
//	if((data & PER_DGT_KU) == 0)
//        drive->ang[X] += DEGtoANG(4.0);
//	if((data & PER_DGT_KD) == 0)
//        drive->ang[X] -= DEGtoANG(4.0);
	/*---------------------------------------------*/
	data = Smpc_Peripheral[nPer].data;
#ifdef FLASH_SATURN_CD
	if((data & (PER_DGT_ST | PER_DGT_TA | PER_DGT_TB | PER_DGT_TC)) == 0){
		SYS_Exit(0);
	}
#endif
	if((data & PER_DGT_ST) == 0) {
	    MENU3D_MENU_setValues(txt_menu, player);
        TXTMEN_setCallafter(txt_menu, 0, player, MENU3D_callback);
	    TXTMEN_execute(txt_menu);
	    TXTSCR_clear(txt_scroll, TXT_DRAW_BOTH);
	    DRV_drawHUD(NULL, 0);
    }    
    // accelerate
	aa = 0;
	if((data & PER_DGT_TB) == 0) {
		if(drive->eg_speed < 0) {
			drive->eg_speed = 0;
		} else {
		    drive->eg_speed += car->speed.unit;
			if(drive->eg_speed > car->speed.max)
                drive->eg_speed = car->speed.max;
		}
		aa = 1;
	}
	// break
	if((data & PER_DGT_TY) == 0) {
		if(drive->eg_speed > 0) {
			drive->eg_speed = 0;
		} else {
		    drive->eg_speed -= car->speed.unit;
			if(drive->eg_speed < car->speed.min)
                drive->eg_speed = car->speed.min;
		}
		aa = 1;
	}
    // automatic slowdown
	if(aa == 0) {
		if(drive->eg_speed > 0)
            drive->eg_speed -= car->speed.unit;
		else if(drive->eg_speed < 0)
            drive->eg_speed += car->speed.unit;
	}
    // compute movement vector
	drive->pos_add[X] += slMulFX(drive->eg_speed, drive->sineY);
	drive->pos_add[Z] += slMulFX(drive->eg_speed, drive->cosineY);
// ? what about the collDirX, collDirZ
// ? why is collDirX = 3*A, see collision_put()
// seems to be the collision response 
//    drive->pos_add[X] += player->coll.dirX;
//    drive->pos_add[Z] += player->coll.dirZ;
	/*---------------------------------------------*/
    // slide left/right    
	if((data & PER_DGT_TL) == 0) {
		drive->pos[X] -= 3*drive->cosineY;
		drive->pos[Z] += 3*drive->sineY;
	}
	if((data & PER_DGT_TR) == 0) {
		drive->pos[X] += 3*drive->cosineY;
		drive->pos[Z] -= 3*drive->sineY;
	}
	/*---------------------------------------------*/
    // when KL or KR are pressed,
    // it changes ang_add always,
    // but changes pos_add only on press
    // ? does steering slow down movement ?
	aa = 0;
	if((data & PER_DGT_KR) == 0) {
		drive->ang_add	+= car->ang.unit;
		aa = 1;
		if(drive->pos_add2_xx == 0) {
			drive->pos_add[X] = drive->pos_add[X]/2;
			drive->pos_add[Y] = drive->pos_add[Y]/2;
			drive->pos_add[Z] = drive->pos_add[Z]/2;
			drive->pos_add2[X] = drive->pos_add[X];
			drive->pos_add2[Y] = drive->pos_add[Y];
			drive->pos_add2[Z] = drive->pos_add[Z];
		}
		drive->pos_add2_xx = 1;
	}
	if((data & PER_DGT_KL) == 0) {
		drive->ang_add	-= car->ang.unit;
		aa = 1;
		if(drive->pos_add2_xx == 0) {
			drive->pos_add[X] = drive->pos_add[X]/2;
			drive->pos_add[Y] = drive->pos_add[Y]/2;
			drive->pos_add[Z] = drive->pos_add[Z]/2;
			drive->pos_add2[X] = drive->pos_add[X];
			drive->pos_add2[Y] = drive->pos_add[Y];
			drive->pos_add2[Z] = drive->pos_add[Z];
		}
		drive->pos_add2_xx	= 1;
	}
	if(aa == 0)
        drive->pos_add2_xx = 0;
	/*---------------------------------------------*/
    // this is a potential new position
    // influenced by 2 forces
    ax = drive->pos[X] + drive->pos_add[X] + drive->pos_add2[X];
    ay = drive->pos[Y] + drive->pos_add[Y] + drive->pos_add2[Y];
    az = drive->pos[Z] + drive->pos_add[Z] + drive->pos_add2[Z];

// uses a different coo.-system as saturn,
// just like the map
    // necessary for pos_add?
    // it is recomputed every frame
	drive->pos_add[X] = slMulFX(drive->pos_add[X], car->paDec);
	drive->pos_add[Y] = slMulFX(drive->pos_add[Y], car->paDec);
	drive->pos_add[Z] = slMulFX(drive->pos_add[Z], car->paDec);
	// this instead is neccessary
	drive->pos_add2[X] = slMulFX(drive->pos_add2[X], car->pa2Dec);
	drive->pos_add2[Y] = slMulFX(drive->pos_add2[X], car->pa2Dec);
	drive->pos_add2[Z] = slMulFX(drive->pos_add2[X], car->pa2Dec);
    // checking for collision left and right

	collPoint[X] = ax - (car->width >> 1)*drive->cosineY;
	collPoint[Z] = az + (car->width >> 1)*drive->sineY;
	// debug
	coll->left.hit = 0;
	coll->left.typeID = 111;
    MAP_checkGround(player->map, collPoint, toFIXED(100), drive->sineY, drive->cosineY, &(coll->left.hit), &(coll->left.typeID), NULL, NULL, NULL, NULL, NULL);

	collPoint[X] = ax + (car->width >> 1)*drive->cosineY;
	collPoint[Z] = az - (car->width >> 1)*drive->sineY;
	// debug
	coll->right.hit = 0;
	coll->right.typeID = 111;
    MAP_checkGround(player->map, collPoint, toFIXED(100), drive->sineY, drive->cosineY, &(coll->right.hit), &(coll->right.typeID), NULL, NULL, NULL, NULL, NULL);
//    point_l = 0;
//    point_r = 0;

    // what type of collision?
    // at least one point on track?
	if(1) { //(((coll->left.hit == 1) && (coll->left.typeID == 0)) || ((coll->right.hit == 1) && (coll->right.typeID == 0))) {
		if(1) { //(coll->left.typeID == 0 && coll->right.typeID == 0) {	// no collision
			drive->pos[X] = ax;
			drive->pos[Z] = az;
		}
// one side is colliding
// different collision strength
// modifies angle and shifts new position 

// these two things happen when the car collides with track border       
//		if(coll->right.typeID == 1) {
//			drive->ang_add -= DEGtoANG(2.0);
//			drive->pos[X] = ax - 2*drive->cosineY;
//			drive->pos[Z] = az + 2*drive->sineY;
//		}
//		if(coll->left.typeID == 1) {
//			drive->ang_add += DEGtoANG(2.0);
//			drive->pos[X] = ax + 2*drive->cosineY;
//			drive->pos[Z] = az - 2*drive->sineY;
//		}
	} else {
        // both sides out of track!!!
        // DON'T do this movement
        // invert direction of movement
		drive->pos_add[X]	= -drive->pos_add[X];
		drive->pos_add[Z]	= -drive->pos_add[Z];
		drive->pos_add2[X]	= -drive->pos_add2[X];
		drive->pos_add2[Z]	= -drive->pos_add2[Z];
        // recompute new position
		ax = drive->pos[X] + drive->pos_add[X] + drive->pos_add2[X];
		az = drive->pos[Z] + drive->pos_add[Z] + drive->pos_add2[Z];
		drive->eg_speed	= 0;
	}
	if((data & PER_DGT_TX) == 0)
        drive->pos[Y] -= toFIXED(4.0);
	if((data & PER_DGT_TA) == 0)
        drive->pos[Y] += toFIXED(4.0);
    if((data & PER_DGT_TZ) == 0)
        cam->pos[Z] += toFIXED(1.0);
    if((data & PER_DGT_TC) == 0)
        cam->pos[Z] -= toFIXED(1.0);

    coll->mid.hit = coll->dirX = coll->dirZ = coll->height = coll->angX = 0;
    MAP_checkGround(player->map, drive->pos, toFIXED(100), drive->sineY, drive->cosineY, &(coll->mid.hit), NULL, &(coll->height), &(coll->dirX), &(coll->dirZ), &(coll->angX), NULL);
	coll->dirX *= car->downforce;
	coll->dirZ *= car->downforce;
//	drive->ang[X] += (coll->angX - drive->ang[X])>>4;
	drive->pos[Y] = coll->height + drive->heightOffset;

	/*---------------------------------------------*/
	drive->ang[Z] = -(drive->ang_add);
	drive->ang[Y] = drive->ang[Y]+(drive->ang_add>>1);
	drive->ang_add	= slMulFX(drive->ang_add, car->aaDec);

    // everytime angZ is changed, compute the sine/cosine values
    drive->sineY = slSin(drive->ang[Y]);
    drive->cosineY = slCos(drive->ang[Y]);
    
//    // only debugging, remove!
//    coll->left.typeID = 20;
//    coll->right.typeID = 30;
//    coll->mid.hit = 2;
//	coll->dirX = toFIXED(1.0);
//	coll->dirZ = toFIXED(1.0);
}


void DRV_cam(Player *player)
{
	slUnitMatrix(CURRENT);
	slLookAt(player->cam.pos, player->cam.target, player->cam.angZ);
}


void MENU3D_callback(int item, void *ptr)
{
    if(ptr != NULL) {
        DRV_cam(ptr);
        DRV_drawTrack(((Player *)ptr)->map, ptr);
        DRV_drawCar(ptr);
        DRV_drawScrolls(ptr);
        DRV_movePos(ptr);
    }    
    slSynch();
}    

void DRV_1Player(Player *player, Uint8 nPer)
{
    if(player == NULL)
        return;
    
    DRV_pad(player, nPer);
    DRV_cam(player);
    DRV_drawTrack(player->map, player);
    DRV_drawCar(player);
    DRV_drawScrolls(player);
    DRV_movePos(player);
}

void DRV_2Player(Player *player1, Player *player2)
{
    if((player1 == NULL) || (player2 == NULL))
        return;

    // first player / top half 
    slWindow(player1->window.left, player1->window.top, player1->window.right, player1->window.bottom, 150, player1->window.vanishX, player1->window.vanishY);
    DRV_1Player(player1, 0);
    // second player / bottom half 
    slWindow(player2->window.left, player2->window.top, player2->window.right, player2->window.bottom, 150, player2->window.vanishX, player2->window.vanishY);
    DRV_1Player(player2, 15);
}

void DRV_set2Player(Player *player1, Player *player2, Uint16 screenWidth, Uint16 screenHeight, Uint8 vSplit)
{
    if((player1 == NULL) || (player2 == NULL))
        return;
        
    if(vSplit == 0) {
        // top half
        player1->window.left = 0;    
        player1->window.top = 0;    
        player1->window.right = screenWidth-1;    
        player1->window.bottom = (screenHeight>>1)-1;
        player1->window.vanishX = screenWidth>>1;
        player1->window.vanishY = screenHeight>>2;
        // bottom half
        player2->window.left = 0;    
        player2->window.top = screenHeight>>1;    
        player2->window.right = screenWidth-1;    
        player2->window.bottom = screenHeight-1;    
        player2->window.vanishX = screenWidth>>1;
        player2->window.vanishY = (screenHeight>>1) + (screenHeight>>2);
    } else {
        // left half
        player1->window.left = 0;    
        player1->window.top = 0;    
        player1->window.right = (screenWidth>>1)-1;    
        player1->window.bottom = screenHeight-1;    
        player1->window.vanishX = screenWidth>>2;
        player1->window.vanishY = screenHeight>>1;
        // right half
        player2->window.left = screenWidth>>1;    
        player2->window.top = 0;    
        player2->window.right = screenWidth-1;    
        player2->window.bottom = screenHeight-1;    
        player2->window.vanishX = (screenWidth>>1) + (screenWidth>>2);
        player2->window.vanishY = screenHeight>>1;
       }
}

void DRV_setWindow(MapData *map, Uint16 mode)
{
    int x, z, o, i;
    TileData *tile;
    
    if(map == NULL)
        return;
    
    for(z = 0; z < map->mapSize.z; z++) {
        for(x = 0; x < map->mapSize.x; x++) {
            tile = *(map->tiles + z*map->mapSize.x + x);
            if(tile == NULL)
                continue;
            for(o = 0; o < tile->nObj; o++) {
                for(i = 0; i < (tile->obj + o)->data.nbPolygon; i++) {
                    ((tile->obj + o)->data.attbl + i)->sort |= UseClip;
                    ((tile->obj + o)->data.attbl + i)->atrb |= Window_In;
                }
            }
        }
    }
}

void	ss_main(void)
{
    unsigned char players = 1;
    unsigned char vSplit = 1;
    
//    map = &map_driving;
    ZdspLevel = 6;
    WindowClipLevel = 50;
    Perspective = DEGtoANG(80);
    
	slInitSystem(TV_320x240,tex_sample,2);
	// is this needed?
//	slInitMatrix();

//checkGroundMap(map, 100, 100, toFIXED(20.0));

	slTVOff();
	DRV_drawHUD(NULL, 0);
#ifdef USE_SCROLLS
	slColRAMMode(CRM16_2048);
	init_vdp2();
#endif	
#ifndef USE_CUSTOM_MAP
	set_texture(pic_sample,7);
#endif	
	slTVOn();
/*--------------------------------------------------------------------------*/
    DRV_initPlayer(&player1);
    DRV_initPlayer(&player2);
	DRV_movePos(&player1);
	DRV_movePos(&player2);
    player1.map = &map_driving;
    player2.map = &map_driving;
	DRV_set2Player(&player1, &player2, 320, 240, vSplit);
	
	slZdspLevel(ZdspLevel);
	slWindowClipLevel(WindowClipLevel);
/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/
#ifdef USE_DEPTH
	slPerspective(Perspective);
	slSetDepthLimit(0,11,5);
	slSetDepthTbl(DepthData,0xf000,32);
	/*--------------------------------------*/
	slInitGouraud((GOURAUDTBL *)gr_tab,(Uint32)300,0xe000,(Uint8 *)point_temp);
	slIntFunction(slGouraudTblCopy);
	/*--------------------------------------*/
	slNearClipFlag(1);
#endif

    // init menu
        // prepare the TXT scroll stuff
    TXTSCR_initScreen(&txt_screen, TXT_SCROLL_XRES, TXT_SCROLL_YRES);
    TXTSCR_initScroll(&txt_scroll, txt_screen, TXT_SCROLL_XRES, TXT_SCROLL_YRES, 0, 0);
    MENU3D_MENU_init(&txt_menu, txt_scroll, "exit", &player1);
    TXTMEN_setCallafter(txt_menu, 0, &player1, MENU3D_callback);

//    DRV_setWindow(map, Window_In);
//    were_here("Window set");
	while(1) {
#ifdef FLASH_SATURN_CD
        if( CDC_GetHirqReq() & CDC_HIRQ_DCHG )
            SYS_Exit(1);
#endif

        // manage player & split screen type change
        if((Smpc_Peripheral[0].push & PER_DGT_TZ) == 0) {
            if(players == 1) {
                vSplit = 0;
                players = 2;
                DRV_set2Player(&player1, &player2, 320, 240, vSplit);
            } else if(players == 2) {
                if(vSplit == 0) {
                    vSplit = 1;
                    DRV_set2Player(&player1, &player2, 320, 240, vSplit);
                } else {
                    vSplit = 0;
                    players = 1;
                    // reset default window
                    slWindow(0, 0, 319, 239, 0x7FFF, 160, 140);
                }    
            }    
        }
        // play the game for one frame
        if(players == 1)
            DRV_1Player(&player1, 0);
        else
            DRV_2Player(&player1, &player2);

        
        DRV_drawHUD(&player1, 1);

		slSynch();
	} 
}

