//                                                                                
//    Copyright (c) 2004/2005 Thomas Fuchs / The Rockin'-B, www.rockin-b.de       
//                                                                                
//    Permission is granted to anyone to use this software for any purpose        
//    and to redistribute it freely, subject to the following restrictions:       
//                                                                                
//    1.  The origin of this software must not be misrepresented. You must not    
//        claim that you wrote the original software. If you use this software    
//        in a product, an acknowledgment in the product documentation would be   
//        appreciated but is not required.                                        
//                                                                                
//    2.  ANY COMMERCIAL USE IS PROHIBITED. This includes that you must not use   
//        this software in the production of a commercial product. Only an explicit
//        permission by the author can allow you to do that.                      
//                                                                                
//    3.  Any modification applied to the software must be marked as such clearly.
//                                                                                
//    4.  This license may not be removed or altered from any distribution.       
//                                                                                
//                                                                                
//    			    NO WARRANTY                                                 
//                                                                                
//    THERE IS NO WARRANTY FOR THE PROGRAM.                                       
//    THE PROGRAM IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND,               
//    EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO,                 
//    THE IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR PURPOSE.                 
//    THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH YOU.
//    SHOULD THE PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY    
//    SERVICING, REPAIR OR CORRECTION.                                            
//                                                                                
//    IN NO EVENT WILL THE COPYRIGHT HOLDER BE LIABLE TO YOU FOR DAMAGES,         
//    INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING 
//    OUT OF THE USE OR INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT LIMITED   
//    TO LOSS OF DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY    
//    YOU OR THIRD PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY OTHER  
//    PROGRAMS), EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE       
//    POSSIBILITY OF SUCH DAMAGES.                                                
//                                                                                

#include <SGL.H>
#include "RB_DRV_draw.h"

extern	Uint16	TotalPolygons;
extern	Uint16	DispPolygons;



#include "3DGFX/DRV_sphere.mdl"
POINT point_sample[]={
	POStoFIXED(-50.0, -50.0, -50.0),
	POStoFIXED(-50.0, -50.0,  50.0),
	POStoFIXED(-50.0,  50.0, -50.0),
	POStoFIXED(-50.0,  50.0,  50.0),
	POStoFIXED( 50.0, -50.0, -50.0),
	POStoFIXED( 50.0, -50.0,  50.0),
	POStoFIXED( 50.0,  50.0, -50.0),
	POStoFIXED( 50.0,  50.0,  50.0),
};

POLYGON polygon_sample[]={
	NORMAL(-1.0,  0.0,  0.0), VERTICES(0, 1, 3, 2),
	NORMAL( 0.0,  0.0,  1.0), VERTICES(1, 5, 7, 3),
	NORMAL( 1.0,  0.0,  0.0), VERTICES(5, 4, 6, 7),
	NORMAL( 0.0,  0.0, -1.0), VERTICES(4, 0, 2, 6),
	NORMAL( 0.0, -1.0,  0.0), VERTICES(4, 5, 1, 0),
	NORMAL( 0.0,  1.0,  0.0), VERTICES(2, 3, 7, 6),
};


ATTR attribute_sample[]={
	ATTRIBUTE(Single_Plane, SORT_MIN, No_Texture, C_RGB( 0, 20, 28), No_Gouraud, MESHoff, sprPolygon, No_Option),
	ATTRIBUTE(Single_Plane, SORT_MIN, No_Texture, C_RGB(28,  8,  0), No_Gouraud, MESHoff, sprPolygon, No_Option),
	ATTRIBUTE(Single_Plane, SORT_MIN, No_Texture, C_RGB( 8, 28,  0), No_Gouraud, MESHoff, sprPolygon, No_Option),
	ATTRIBUTE(Single_Plane, SORT_MIN, No_Texture, C_RGB(28, 20,  0), No_Gouraud, MESHoff, sprPolygon, No_Option),
	ATTRIBUTE(Single_Plane, SORT_MIN, No_Texture, C_RGB(16,  0, 28), No_Gouraud, MESHoff, sprPolygon, No_Option),
	ATTRIBUTE(Single_Plane, SORT_MIN, No_Texture, C_RGB(28, 20, 16), No_Gouraud, MESHoff, sprPolygon, No_Option),
};

//PDATA wheel = {
//	point_sample, sizeof(point_sample) / sizeof(POINT),
//	polygon_sample, sizeof(polygon_sample) / sizeof(POLYGON),
//	attribute_sample
//};
    PDATA wheel = {
    	point_Meshes, sizeof(point_Meshes)/sizeof(POINT),
    	polygon_Meshes, sizeof(polygon_Meshes)/sizeof(POLYGON),
    	attribute_Meshes,
    };


void DRV_setMatrix(FIXED *pos, ANGLE *ang)
{
    // NOTE: need to perform the inverse movement to the track
    // to get the player on right position
	slRotZ(ang[Z]);
	slRotX(ang[X]);
	slRotY(-ang[Y]);
	slTranslate(-pos[X], -pos[Y], -pos[Z]);
}


void DRV_drawHUD(Player *player, unsigned char mode)
{
    if(mode == 0) {
        slPrint("[Extended 3D Driving Sample]" , slLocate(6,2));
        
        slPrint("TotalPolygons", slLocate(3,4));
        slPrint("DispPolygons", slLocate(3,5));
        
        slPrint("eg_speed", slLocate(3,7));
        slPrint("ang_add", slLocate(3,8));

        slPrint("pos", slLocate(3,10));
        slPrint("pos", slLocate(3,11));
        slPrint("pos", slLocate(3,12));
        slPrint("ang", slLocate(3,14));
        slPrint("ang", slLocate(3,15));
        slPrint("ang", slLocate(3,16));
        
        slPrint("collHit", slLocate(3,18));
        slPrint("collHeight", slLocate(3,19));
        slPrint("collDirX", slLocate(3,20));
        slPrint("collDirZ", slLocate(3,21));
        slPrint("collAngX", slLocate(3,22));
        slPrint("collAngZ", slLocate(3,23));
        slPrint("collide left", slLocate(3,24));
        slPrint("collide right", slLocate(3,25));
        slPrint("cpos[Z]", slLocate(3,27));
    } else {
        slPrintFX(TotalPolygons << 16, slLocate(20,4));
        slPrintFX(DispPolygons << 16, slLocate(20,5));

        slPrintFX(player->drive.eg_speed, slLocate(20,7));
        slPrintFX(player->drive.ang_add, slLocate(20,8));

		slPrintFX(player->drive.pos[X], slLocate(20,10));
		slPrintFX(player->drive.pos[Y], slLocate(20,11));
		slPrintFX(player->drive.pos[Z], slLocate(20,12));
		slPrintFX(player->drive.ang[X], slLocate(20,14));
		slPrintFX(player->drive.ang[Y], slLocate(20,15));
		slPrintFX(player->drive.ang[Z], slLocate(20,16));

		slPrintFX(((unsigned int)player->coll.mid.hit) << 16, slLocate(20,18));
		slPrintFX(player->coll.height, slLocate(20,19));
		slPrintFX(player->coll.dirX, slLocate(20,20));
		slPrintFX(player->coll.dirZ, slLocate(20,21));
		slPrintFX(player->coll.angX, slLocate(20,22));
		slPrintFX(player->coll.angZ, slLocate(20,23));

        slPrintFX(((unsigned int)player->coll.left.typeID) << 16, slLocate(20,24));
		slPrintFX(((unsigned int)player->coll.right.typeID) <<16, slLocate(20,25));

		slPrintFX(player->cam.pos[Z], slLocate(20,27));
    }    
}


// neccessary on Saturn
#define toFLOAT(fx)			(((float)fx) / 65536.0)
#define slDivFX_Map(a, b) toFIXED(toFLOAT(a) / toFLOAT(b))
//#define slDivFX_Map(a, b) slDivFX(a, b)

// defines the middle sized square of tiles
// which are checked to draw onto screen
#define SQUARE_M_SIZE_X  30
#define SQUARE_M_SIZE_Z  30
// defines the small sized square which is drawn directly
// without slCheckOnScreen()
// format: FIXED, tile relative
#define SQUARE_S_SIZE_X  toFIXED(4.0)
#define SQUARE_S_SIZE_Z  toFIXED(4.0)

void DRV_drawTrack(MapData *map, Player *player)
{
	FIXED	pom[XYZ];
	Sint32	MyAbsX,MyAbsZ;
	Sint32	ax,az;
	Sint32	my_xx, my_zz;
	Sint32	X_MAX, X_MIN;
	Sint32	Z_MAX, Z_MIN;
	TileData *tile;
	FIXED maxHalfTileSize;
	int i;
	
	// for slCheckOnScreen()
	maxHalfTileSize = map->tileSize.x;
	if(map->tileSize.x < map->tileSize.z)
	   maxHalfTileSize = map->tileSize.z;
    maxHalfTileSize >>= 1;
	
	
	// find out the tile I'm in
//	my_xx = slDivFX_Map(player->drive.pos[X] - map->mapOrigin.x, map->tileSize.x);
//	my_zz = slDivFX_Map(player->drive.pos[Z] - map->mapOrigin.z, map->tileSize.z);
	my_xx = (player->drive.pos[X] - map->mapOrigin.x) >> (map->tileSize.x - 16);
	my_zz = (player->drive.pos[Z] - map->mapOrigin.z) >> (map->tileSize.z - 16);
	
	slPushMatrix();
	{
		// transform
        DRV_setMatrix(player->drive.pos, player->drive.ang);		
        // create a square of tiles to
        // possibly draw onto screen
		X_MIN = (my_xx >> 16) - (SQUARE_M_SIZE_X/2 - 1);
		X_MAX = (my_xx >> 16) + (SQUARE_M_SIZE_X/2);

		if(X_MIN < 0) 
            X_MIN = 0;
		if(X_MAX > map->mapSize.x)
            X_MAX = map->mapSize.x;
        
//        // too far outside of map?
//        // cannot happen in game
//        if(X_MIN > X_MAX) {
//            slPopMatrix();
//            return;
//        }    
		
		Z_MIN = (my_zz >> 16) - (SQUARE_M_SIZE_Z/2 - 1);
		Z_MAX = (my_zz >> 16) + (SQUARE_M_SIZE_Z/2);

		if(Z_MIN < 0) 
            Z_MIN = 0;
		if(Z_MAX > map->mapSize.z)
            Z_MAX = map->mapSize.z;
		
//        // too far outside of map?
//        // cannot happen in game
//        if(X_MIN > X_MAX) {
//            slPopMatrix();
//            return;
//        }    

		for(ax = X_MIN; ax < X_MAX; ax++) {
			for(az = Z_MIN; az < Z_MAX; az++) {
			    // fetch tile
			    tile = *(map->tiles + az*map->mapSize.x + ax);
			    if((tile == NULL) || (tile->nObj == 0))
                    continue;
#if 1
                // seems to be some view frustrum culling
                // the map and car position in screen middle allow for that
                // to outperform slCheckOnScreen()
                MyAbsX	= abs((ax << 16) - my_xx);
                MyAbsZ	= abs((az << 16) - my_zz);
                // do we need slCheckOnScreen()?
                if(!((MyAbsX < (SQUARE_S_SIZE_X/2)) && (MyAbsZ < (SQUARE_S_SIZE_Z/2)))) {
                    // compute tile middle
                    pom[X] = (ax << 16) + (map->tileSize.x >> 1);
                    pom[Y] = 0;
                    pom[Z] = (az << 16) + (map->tileSize.z >> 1);
                    // not on screen?
                    if(slCheckOnScreen(pom, maxHalfTileSize) < 0)
					   continue;
                }
#endif
                // still here?
                // draw everything
                for(i = 0; i < tile->nObj; i++) {
                    if((tile->obj + i)->type == IS_PDATA)
    				    slPutPolygon((PDATA *)&((tile->obj + i)->data));
                    else if((tile->obj + i)->type == IS_XPDATA)
    				    slPutPolygonX((XPDATA *)&((tile->obj + i)->data), NULL);
                }				
			}
		}
	}
    slPopMatrix();
}


void DRV_drawScrolls(Player *player)
{
    if(player == NULL)
        return;
        
	slPushMatrix();
	{
		DRV_setMatrix(player->drive.pos2, player->drive.ang2);
        slRotX(DEGtoANG(-90));

		slCurRpara(RA);
		slScrMatConv();
		slScrMatSet();
	}
	slPopMatrix();
	slPushMatrix();
	{
		slTranslate(toFIXED(160.0)+(player->drive.ang2[Y]<<10), toFIXED(154.0)-112*slCos(DEGtoANG(90) + player->drive.ang2[X]), toFIXED(100.0));
		slRotZ(-player->drive.ang2[Z]);
		slCurRpara(RB);
		slScrMatSet();
	}
	slPopMatrix();
}


#include "RB_were_here.h"
void DRV_drawCar(Player *player)
{
    FIXED pos[XYZ];
    MATRIX mat;

// some strange unknown bug
// causes unknown opcode error in Satourne
// when calling slPutPolygon between matrix push/pop here
// fixed: don't ever forget the braces after slPushMatrix() or slPopMatrix()

    if(player == NULL)
        return;

    pos[Y] = player->drive.pos[Y];

    // left front side
    slPushMatrix();
    {
        slTranslate(-(player->car.width << 15), toFIXED(2.5), 0);
        slPutPolygon(&wheel);
    }
    slPopMatrix();
    // right front side
    slPushMatrix();
    {
        slTranslate((player->car.width << 15), toFIXED(2.5), 0);
        slPutPolygon(&wheel);
    }
    slPopMatrix();
    // middle point
    slPushMatrix();
    {
        slTranslate(0, toFIXED(2.5), 0);
        slPutPolygon(&wheel);
    }
    slPopMatrix();
}

