//                                                                                
//    Copyright (c) 2004/2005 Thomas Fuchs / The Rockin'-B, www.rockin-b.de       
//                                                                                
//    Permission is granted to anyone to use this software for any purpose        
//    and to redistribute it freely, subject to the following restrictions:       
//                                                                                
//    1.  The origin of this software must not be misrepresented. You must not    
//        claim that you wrote the original software. If you use this software    
//        in a product, an acknowledgment in the product documentation would be   
//        appreciated but is not required.                                        
//                                                                                
//    2.  ANY COMMERCIAL USE IS PROHIBITED. This includes that you must not use   
//        this software in the production of a commercial product. Only an explicit
//        permission by the author can allow you to do that.                      
//                                                                                
//    3.  Any modification applied to the software must be marked as such clearly.
//                                                                                
//    4.  This license may not be removed or altered from any distribution.       
//                                                                                
//                                                                                
//    			    NO WARRANTY                                                 
//                                                                                
//    THERE IS NO WARRANTY FOR THE PROGRAM.                                       
//    THE PROGRAM IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND,               
//    EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO,                 
//    THE IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR PURPOSE.                 
//    THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH YOU.
//    SHOULD THE PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY    
//    SERVICING, REPAIR OR CORRECTION.                                            
//                                                                                
//    IN NO EVENT WILL THE COPYRIGHT HOLDER BE LIABLE TO YOU FOR DAMAGES,         
//    INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING 
//    OUT OF THE USE OR INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT LIMITED   
//    TO LOSS OF DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY    
//    YOU OR THIRD PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY OTHER  
//    PROGRAMS), EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE       
//    POSSIBILITY OF SUCH DAMAGES.                                                
//                                                                                

#include <SGL.H>
// !!! you should better not forget this include
// for an unknown reason, gcc doesn't complain and the
// 3D menu is corrupted
#include <RB_TXT_MENU.h>
#include "RB_menu3D.h"

#define toFLOAT(fx)         (((float)fx) / 65536.0)
#define ANGtoDEG(a)         ((((float)a) * 360.0) / 65536.0)

static Player *my_player;

extern FIXED light[XYZ];
extern ANGLE light_ang[XYZ];

extern Uint16 ZdspLevel;
extern Sint32 WindowClipLevel;
extern ANGLE Perspective;



void MENU3D_computeLight(FIXED *light, ANGLE *light_ang)
{
    FIXED light_init[XYZ] = { toFIXED(0.57735026), toFIXED(0.57735026), toFIXED(0.57735026) };
    
    slPushUnitMatrix();
    {
        // perform rotation
        slRotX(light_ang[X]);            								 
        slRotY(light_ang[Y]);			   
        slRotZ(light_ang[Z]);
        // transform light vector
        slCalcVector(light_init, light);
    }
    slPopMatrix();
}


void MENU3D_MENU_callback(int item, void *ptr)
{
//    were_here("in callback MENU3D_MENU_AFTER, ptr %i", ptr);
    if(ptr == NULL)
        return;

    switch(item) {
        // 3D debug
        case MENU3D_MENU_ANGX:
            my_player->drive.ang[X] = DEGtoANG(TXTMEN_getFloatValueAt(ptr, MENU3D_MENU_ANGX));
            return;

        case MENU3D_MENU_ANGY:
            my_player->drive.ang[Y] = DEGtoANG(TXTMEN_getFloatValueAt(ptr, MENU3D_MENU_ANGY));
            return;

        case MENU3D_MENU_ANGZ:
            my_player->drive.ang[Z] = DEGtoANG(TXTMEN_getFloatValueAt(ptr, MENU3D_MENU_ANGZ));
            return;

        case MENU3D_MENU_POSX:
            my_player->drive.pos[X] = toFIXED(TXTMEN_getFloatValueAt(ptr, MENU3D_MENU_POSX));
            return;

        case MENU3D_MENU_POSY:
            my_player->drive.pos[Y] = toFIXED(TXTMEN_getFloatValueAt(ptr, MENU3D_MENU_POSY));
            return;

        case MENU3D_MENU_POSZ:
            my_player->drive.pos[Z] = toFIXED(TXTMEN_getFloatValueAt(ptr, MENU3D_MENU_POSZ));
            return;

        case MENU3D_MENU_CANGZ:
            my_player->cam.angZ = DEGtoANG(TXTMEN_getFloatValueAt(ptr, MENU3D_MENU_CANGZ));
            return;

        case MENU3D_MENU_CPOSX:
            my_player->cam.pos[X] = toFIXED(TXTMEN_getFloatValueAt(ptr, MENU3D_MENU_CPOSX));
            return;

        case MENU3D_MENU_CPOSY:
            my_player->cam.pos[Y] = toFIXED(TXTMEN_getFloatValueAt(ptr, MENU3D_MENU_CPOSY));
            return;

        case MENU3D_MENU_CPOSZ:
            my_player->cam.pos[Z] = toFIXED(TXTMEN_getFloatValueAt(ptr, MENU3D_MENU_CPOSZ));
            return;

        case MENU3D_MENU_CTARX:
            my_player->cam.target[X] = toFIXED(TXTMEN_getFloatValueAt(ptr, MENU3D_MENU_CTARX));
            return;

        case MENU3D_MENU_CTARY:
            my_player->cam.target[Y] = toFIXED(TXTMEN_getFloatValueAt(ptr, MENU3D_MENU_CTARY));
            return;

        case MENU3D_MENU_CTARZ:
            my_player->cam.target[Z] = toFIXED(TXTMEN_getFloatValueAt(ptr, MENU3D_MENU_CTARZ));
            return;

        case MENU3D_MENU_LIGHTX:
            light_ang[X] = DEGtoANG(TXTMEN_getFloatValueAt(ptr, MENU3D_MENU_LIGHTX));
            return;

        case MENU3D_MENU_LIGHTY:
            light_ang[Y] = DEGtoANG(TXTMEN_getFloatValueAt(ptr, MENU3D_MENU_LIGHTY));
            return;

        case MENU3D_MENU_LIGHTZ:
            light_ang[Z] = DEGtoANG(TXTMEN_getFloatValueAt(ptr, MENU3D_MENU_LIGHTZ));
            return;

        case MENU3D_MENU_ZLEVEL:
            ZdspLevel = TXTMEN_getIntValueAt(ptr, MENU3D_MENU_ZLEVEL);
            slZdspLevel(ZdspLevel);
            return;

        case MENU3D_MENU_WLEVEL:
            WindowClipLevel = TXTMEN_getIntValueAt(ptr, MENU3D_MENU_WLEVEL);
            slWindowClipLevel(WindowClipLevel);
            return;

        case MENU3D_MENU_PERSPECTIVE:
            Perspective = DEGtoANG(TXTMEN_getFloatValueAt(ptr, MENU3D_MENU_PERSPECTIVE));
            slPerspective(Perspective);
            return;

        case MENU3D_MENU_EXIT:
            TXTMEN_leave(ptr);
            return;

    }    
}



void MENU3D_MENU_setValues(void *menu, Player *new_player)
{
    if((new_player == NULL) || (menu == NULL))
        return;
        
    my_player = new_player;
        // rotation
    TXTMEN_setFloatValueAt(menu, MENU3D_MENU_ANGX, ANGtoDEG(my_player->drive.ang[X]));
    TXTMEN_setFloatValueAt(menu, MENU3D_MENU_ANGY, ANGtoDEG(my_player->drive.ang[Y]));
    TXTMEN_setFloatValueAt(menu, MENU3D_MENU_ANGZ, ANGtoDEG(my_player->drive.ang[Z]));
        // translation
    TXTMEN_setFloatValueAt(menu, MENU3D_MENU_POSX, toFLOAT(my_player->drive.pos[X]));
    TXTMEN_setFloatValueAt(menu, MENU3D_MENU_POSY, toFLOAT(my_player->drive.pos[Y]));
    TXTMEN_setFloatValueAt(menu, MENU3D_MENU_POSZ, toFLOAT(my_player->drive.pos[Z]));
        // cam rotation
    TXTMEN_setFloatValueAt(menu, MENU3D_MENU_CANGZ, ANGtoDEG(my_player->cam.angZ));
        // cam translation
    TXTMEN_setFloatValueAt(menu, MENU3D_MENU_CPOSX, toFLOAT(my_player->cam.pos[X]));
    TXTMEN_setFloatValueAt(menu, MENU3D_MENU_CPOSY, toFLOAT(my_player->cam.pos[Y]));
    TXTMEN_setFloatValueAt(menu, MENU3D_MENU_CPOSZ, toFLOAT(my_player->cam.pos[Z]));
        // cam target
    TXTMEN_setFloatValueAt(menu, MENU3D_MENU_CTARX, toFLOAT(my_player->cam.target[X]));
    TXTMEN_setFloatValueAt(menu, MENU3D_MENU_CTARY, toFLOAT(my_player->cam.target[Y]));
    TXTMEN_setFloatValueAt(menu, MENU3D_MENU_CTARZ, toFLOAT(my_player->cam.target[Z]));
        // light rotation
    TXTMEN_setFloatValueAt(menu, MENU3D_MENU_LIGHTX, ANGtoDEG(light_ang[X]));
    TXTMEN_setFloatValueAt(menu, MENU3D_MENU_LIGHTY, ANGtoDEG(light_ang[Y]));
    TXTMEN_setFloatValueAt(menu, MENU3D_MENU_LIGHTZ, ANGtoDEG(light_ang[Z]));
        // ZdspLevel & WindowCLipLevel
    TXTMEN_setIntValueAt(menu, MENU3D_MENU_ZLEVEL, ZdspLevel);
    TXTMEN_setIntValueAt(menu, MENU3D_MENU_WLEVEL, WindowClipLevel);
        // Perspective
    TXTMEN_setFloatValueAt(menu, MENU3D_MENU_PERSPECTIVE, ANGtoDEG(Perspective));
}


void MENU3D_MENU_init(void **menu, void *scroll, unsigned char *exitText, Player *new_player)
{
    if((new_player == NULL) || (menu == NULL) || (scroll == NULL))
        return;

    my_player = new_player;
    
    TXTMEN_init(menu, scroll, "Driving3 debug menu");
        // rotation
    TXTMEN_addSpinnerFloat(*menu, "angle X", -360, 360, 1, ANGtoDEG(my_player->drive.ang[X]));
    TXTMEN_setCallback(*menu, MENU3D_MENU_ANGX, *menu, MENU3D_MENU_callback);
    TXTMEN_addSpinnerFloat(*menu, "angle Y", -360, 360, 1, ANGtoDEG(my_player->drive.ang[Y]));
    TXTMEN_setCallback(*menu, MENU3D_MENU_ANGY, *menu, MENU3D_MENU_callback);
    TXTMEN_addSpinnerFloat(*menu, "angle Z", -360, 360, 1, ANGtoDEG(my_player->drive.ang[Z]));
    TXTMEN_setCallback(*menu, MENU3D_MENU_ANGZ, *menu, MENU3D_MENU_callback);
        // translation
    TXTMEN_addSpinnerFloat(*menu, "posX", -1000.0, 1000.0, 2, toFLOAT(my_player->drive.pos[X]));
    TXTMEN_setCallback(*menu, MENU3D_MENU_POSX, *menu, MENU3D_MENU_callback);
    TXTMEN_addSpinnerFloat(*menu, "posY", -1000.0, 1000.0, 2, toFLOAT(my_player->drive.pos[Y]));
    TXTMEN_setCallback(*menu, MENU3D_MENU_POSY, *menu, MENU3D_MENU_callback);
    TXTMEN_addSpinnerFloat(*menu, "posZ", -1000.0, 1000.0, 2, toFLOAT(my_player->drive.pos[Z]));
    TXTMEN_setCallback(*menu, MENU3D_MENU_POSZ, *menu, MENU3D_MENU_callback);
        // camera rotation
    TXTMEN_addSpinnerFloat(*menu, "cangle Z", -360, 360, 1, ANGtoDEG(my_player->cam.angZ));
    TXTMEN_setCallback(*menu, MENU3D_MENU_CANGZ, *menu, MENU3D_MENU_callback);
        // camera translation
    TXTMEN_addSpinnerFloat(*menu, "cposX", -1000.0, 1000.0, 3, toFLOAT(my_player->cam.pos[X]));
    TXTMEN_setCallback(*menu, MENU3D_MENU_CPOSX, *menu, MENU3D_MENU_callback);
    TXTMEN_addSpinnerFloat(*menu, "cposY", -1000.0, 1000.0, 3, toFLOAT(my_player->cam.pos[Y]));
    TXTMEN_setCallback(*menu, MENU3D_MENU_CPOSY, *menu, MENU3D_MENU_callback);
    TXTMEN_addSpinnerFloat(*menu, "cposZ", -1000.0, 1000.0, 3, toFLOAT(my_player->cam.pos[Z]));
    TXTMEN_setCallback(*menu, MENU3D_MENU_CPOSZ, *menu, MENU3D_MENU_callback);
        // camera target
    TXTMEN_addSpinnerFloat(*menu, "ctargetX", -1000.0, 1000.0, 2, toFLOAT(my_player->cam.target[X]));
    TXTMEN_setCallback(*menu, MENU3D_MENU_CTARX, *menu, MENU3D_MENU_callback);
    TXTMEN_addSpinnerFloat(*menu, "ctargetY", -1000.0, 1000.0, 2, toFLOAT(my_player->cam.target[Y]));
    TXTMEN_setCallback(*menu, MENU3D_MENU_CTARY, *menu, MENU3D_MENU_callback);
    TXTMEN_addSpinnerFloat(*menu, "ctargetZ", -1000.0, 1000.0, 2, toFLOAT(my_player->cam.target[Z]));
    TXTMEN_setCallback(*menu, MENU3D_MENU_CTARZ, *menu, MENU3D_MENU_callback);
        // light rotation speed
    TXTMEN_addSpinnerFloat(*menu, "light X", -360, 360, 1, ANGtoDEG(light_ang[X]));
    TXTMEN_setCallback(*menu, MENU3D_MENU_LIGHTX, *menu, MENU3D_MENU_callback);
    TXTMEN_addSpinnerFloat(*menu, "light Y", -360, 360, 1, ANGtoDEG(light_ang[Y]));
    TXTMEN_setCallback(*menu, MENU3D_MENU_LIGHTX, *menu, MENU3D_MENU_callback);
    TXTMEN_addSpinnerFloat(*menu, "light Z", -360, 360, 1, ANGtoDEG(light_ang[Z]));
    TXTMEN_setCallback(*menu, MENU3D_MENU_LIGHTX, *menu, MENU3D_MENU_callback);
        // ZdspLevel & WindowCLipLevel
    TXTMEN_addSpinnerInt(*menu, "ZdspLevel", 0, 16, 1, ZdspLevel);
    TXTMEN_setCallback(*menu, MENU3D_MENU_ZLEVEL, *menu, MENU3D_MENU_callback);
    TXTMEN_addSpinnerInt(*menu, "WindowClipLevel", -100, 100, 1, WindowClipLevel);
    TXTMEN_setCallback(*menu, MENU3D_MENU_WLEVEL, *menu, MENU3D_MENU_callback);
        // Perspective
    TXTMEN_addSpinnerFloat(*menu, "Perspective", 10.0, 160.0, 1.0, ANGtoDEG(Perspective));
    TXTMEN_setCallback(*menu, MENU3D_MENU_PERSPECTIVE, *menu, MENU3D_MENU_callback);

    // exit button ?
    if(exitText != NULL) {
        TXTMEN_addButton(*menu, exitText);
        TXTMEN_setCallback(*menu, MENU3D_MENU_EXIT, *menu, MENU3D_MENU_callback);
    }    
}

